"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Graphic_1 = require("./../Graphic");
var Tool_1 = require("./../Tool");
var Dialog = (function (_super) {
    __extends(Dialog, _super);
    /* LIFECYCLE */
    function Dialog() {
        var _this = _super.call(this) || this;
        _this.setProps({
            offsetX: 0,
            offsetY: 0
        });
        _this.connect(_this.signals.propChange, ["width", "height"], _this.onLabelSizeChange.bind(_this));
        return _this;
    }
    Dialog.prototype.initialize = function (props) {
        var _this = this;
        _super.prototype.initialize.call(this, props);
        this.shape("shape", {
            width: this.props.width,
            height: this.props.height,
            stroke: Tool_1.Color.cyan400,
            strokeThickness: 2,
            fill: Tool_1.Color.black,
            fillAlpha: 0.7
        }).text("label", function (label) {
            label.signals.propChange.bind("width", _this.onLabelSizeChange.bind(_this));
            return {
                fill: Tool_1.Color.white,
                y: 10
            };
        });
        this.connect(this.context.scene.signals.propChange, ["width", "height"], this.onScreenSizeChange.bind(this));
        this.onScreenSizeChange();
    };
    /* EVENTS */
    /**
     * When the label width attributes has changed
     */
    Dialog.prototype.onLabelSizeChange = function () {
        var _this = this;
        this.text("label", function (label) {
            return {
                x: (_this.props.width / 2) - (label.props.width / 2)
            };
        });
    };
    Dialog.prototype.onScreenSizeChange = function () {
        var scene = this.context.scene, _a = scene.props, width = _a.width, height = _a.height, _b = this.props, centerScreen = _b.centerScreen, fullScreen = _b.fullScreen, offsetX = _b.offsetX, offsetY = _b.offsetY;
        if (!fullScreen && !centerScreen) {
            return null;
        }
        var pos = this.getRelativePosition();
        if (fullScreen) {
            this.props.x = pos.x + offsetX;
            this.props.y = pos.y + offsetY;
            this.props.width = width;
            this.props.height = height;
            this.shape("shape", {
                width: width,
                height: height
            });
        }
        else if (centerScreen) {
            this.props.x = pos.x + offsetX + (width / 2) - (this.props.width / 2);
            this.props.y = pos.y + offsetY + (height / 2) - (this.props.height / 2);
        }
    };
    return Dialog;
}(Graphic_1.Graphic));
exports.Dialog = Dialog;
